frr version 7.5+cl4.3.0u1
frr defaults datacenter
hostname {{ inventory_hostname }}
username cumulus nopassword
!
service integrated-vtysh-config
!
log syslog informational
!
{% if underlay is defined and 'bgp' in underlay %}
{%   if tenants is defined %}
{%     for tenant in tenants %}
{%       for vrf in tenant.vrfs %}
vrf vrf{{ vrf.id }}
 vni {{ vrf.l3_vni }}
exit-vrf
{%       endfor %}
{%     endfor %}
!
{%   endif %}
router bgp {{ underlay.bgp.asn }}
 bgp router-id {{ lo }}
 bgp bestpath as-path multipath-relax
 neighbor underlay peer-group
 neighbor underlay remote-as external
{%   for port in underlay.bgp.members %}
 neighbor {{ port }} interface peer-group underlay
{%   endfor %}
{%   if mlag is defined %}
 neighbor peerlink.4094 interface remote-as internal
{%   endif %}
 !
 address-family ipv4 unicast
  redistribute connected route-map LOOPBACK_ROUTES
 exit-address-family
 !
 address-family l2vpn evpn
  neighbor underlay activate
  advertise-all-vni
 exit-address-family
!
{%   if edge is defined and 'vrfs' in edge %}
{%     for vrf in edge.vrfs %}
{%       if vrf.bgp is defined %}
router bgp {{ vrf.bgp.asn }} vrf {{ vrf.name }}
 bgp router-id {{ lo }}
{%         for peer_group in vrf.bgp.peer_groups %}
 neighbor {{ peer_group.name }} peer-group
 neighbor {{ peer_group.name }} remote-as {{ peer_group.asn }}
{%           for neighbor in peer_group.neighbors %}
 neighbor {{ neighbor }} peer-group {{ peer_group.name }}
{%           endfor %}
{%         endfor %}
{%       if vrf.peerlink is defined %}
 neighbor peerlink.{{ vrf.peerlink.id }} interface remote-as internal
{%       endif %}
 !
 address-family ipv4 unicast
{%         if vrf.bgp.redistribute is not defined or vrf.bgp.redistribute %}
  redistribute connected
{%         endif %}
{%         if vrf.bgp.aggregate_addresses is defined %}
{%           for aggregate_address in vrf.bgp.aggregate_addresses %}
  aggregate-address {{ aggregate_address.prefix }}{% if aggregate_address.option is defined %} {{ aggregate_address.option }}{% endif +%}
{%           endfor %}
{%         endif %}
{%         if vrf.peerlink is defined and 'prefix_lists' in vrf.peerlink %}
{%           for prefix_list in vrf.peerlink.prefix_lists %}
  neighbor peerlink.{{ vrf.peerlink.id }} prefix-list {{ prefix_list.name }} {{ prefix_list.direction }}
{%           endfor %}
{%         endif %}
{%         for peer_group in vrf.bgp.peer_groups %}
{%           if 'prefix_lists' in peer_group %}
{%             for prefix_list in peer_group.prefix_lists %}
  neighbor {{ peer_group.name }} prefix-list {{ prefix_list.name }} {{ prefix_list.direction }}
{%             endfor %}
{%           endif %}
{%           if 'route_maps' in peer_group %}
{%             for route_map in peer_group.route_maps %}
  neighbor {{ peer_group.name }} route-map {{ route_map.name }} {{ route_map.direction }}
{%             endfor %}
{%           endif %}
{%         endfor %}
{%         if vrf.bgp.imports is defined and vrf.bgp.imports | length %}
{%           for import in vrf.bgp.imports %}
  import vrf {{ import }}
{%           endfor %}
{%         endif %}
 exit-address-family
{%       endif %}
!
{%     endfor %}
{%   endif %}
{%   if tenants is defined %}
{%     for tenant in tenants %}
{%       for vrf in tenant.vrfs %}
router bgp {{ underlay.bgp.asn }} vrf vrf{{ vrf.id }}
 address-family l2vpn evpn
  advertise ipv4 unicast
 exit-address-family
 !
 address-family ipv4 unicast
  redistribute connected
{%         if 'borderleafs' in group_names and vrf.bgp.imports is defined and vrf.bgp.imports | length %}
{%           for import in vrf.bgp.imports %}
  import vrf {{ import }}
{%           endfor %}
{%         endif %}
 exit-address-family
 !
{%       endfor %}
{%     endfor %}
{%   endif %}
{% if prefix_lists is defined and prefix_lists | length %}
{%   for prefix_list in prefix_lists %}
{%     for prefix in prefix_list.prefixes %}
ip prefix-list {{ prefix_list.name }}{% if prefix.seq is defined %} seq {{ prefix.seq }}{% endif %} {{ prefix.policy }} {{ prefix.prefix }}{% if prefix.ge is defined %} ge {{ prefix.ge }}{% endif %}{% if prefix.le is defined %} le {{ prefix.le }}{% endif +%}
{%     endfor %}
{%   endfor %}
!
{% endif %}
{% if route_maps is defined and route_maps | length %}
{%   for route_map in route_maps %}
route-map {{ route_map.name }} {{ route_map.policy }} {{ route_map.seq }}
{%     if 'matches' in route_map and route_map.matches | length %}
{%       for match in route_map.matches %}
  match {{ match }}
{%       endfor %}
{%     endif %}
{%     if 'sets' in route_map and route_map.sets | length %}
{%       for set in route_map.sets %}
  set {{ set }}
{%       endfor %}
{%     endif %}
{%     if 'call' in route_map %}
  call {{ route_map.call }}
{%     endif %}
{%     if 'exit_policy' in route_map %}
  {{ route_map.exit_policy }}
{%     endif %}
{%   endfor %}
!
{% endif %}
route-map LOOPBACK_ROUTES permit 10
  match interface lo
{% endif %}
!
line vty
!
end
